/* cmain.c - Startup code for the UltraSparc.  */
/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (C) 2003, 2004, 2005  Free Software Foundation, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <alloca.h>
#include <stdint.h>
#include <grub/kernel.h>
#include <grub/machine/ieee1275.h>
#include <grub/ieee1275/ieee1275.h>

/* OpenBoot entry point.  */
int (*grub_ieee1275_entry_fn) (void *);

grub_ieee1275_phandle_t grub_ieee1275_chosen;

static grub_uint32_t grub_ieee1275_flags;



int
grub_ieee1275_test_flag (enum grub_ieee1275_flag flag)
{
  return (grub_ieee1275_flags & (1 << flag));
}

void
grub_ieee1275_set_flag (enum grub_ieee1275_flag flag)
{
  grub_ieee1275_flags |= (1 << flag);
}

void
_start (uint64_t r0 __attribute__((unused)),
        uint64_t r1 __attribute__((unused)),
        uint64_t r2 __attribute__((unused)),
        uint64_t r3 __attribute__((unused)),
        uint64_t r4,
        uint64_t r5 __attribute__((unused)));
void
_start (uint64_t r0 __attribute__((unused)),
        uint64_t r1 __attribute__((unused)),
        uint64_t r2 __attribute__((unused)),
        uint64_t r3 __attribute__((unused)),
        uint64_t r4,
        uint64_t r5 __attribute__((unused)))
{
  grub_ieee1275_entry_fn = (int (*)(void *)) r4;

  grub_ieee1275_finddevice ("/chosen", &grub_ieee1275_chosen);

  /* Now invoke the main function.  */
  grub_main ();

  /* Never reached.  */
}
